/**************************************************************************
 *    file:         talkclientDlg.h                                       *
 *    create:       June 9, 2000                                          *
 *    copyright:    @ 2000, by Zhaohui Xing                               *
 *    e-mail:       xinghh@yahoo.com                                      * 
 *    description:  definition of CTalkclientDlg class                    *
 **************************************************************************/

#if !defined(AFX_TALKCLIENTDLG_H__8068D458_3CAB_11D4_8ECB_00805FBDCBE4__INCLUDED_)
#define AFX_TALKCLIENTDLG_H__8068D458_3CAB_11D4_8ECB_00805FBDCBE4__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CTalkclientDlg dialog
#include "vtDef.h"
#include "vtWave.h"


class CTalkclientDlg : public CDialog
{
// Construction
public:
	CTalkclientDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CTalkclientDlg)
	enum { IDD = IDD_TALKCLIENT_DIALOG };
	CButton	m_btnConnect;                  // "Connect" Button 
	CButton	m_btnSendTxtMsg;               // "Send text message" Button 
	CButton	m_chkVoice;                    // "Voice Talk" Radio Button 
	CEdit	m_editUserName;                // "User name" edit box 
	CEdit	m_editServer;                  // " Server" edit box
	CEdit	m_TextRecv;                    // The edit box for the sending out message 
	CEdit	m_TextSend;                    // The edit box for the receiving message
	CComboBox	m_ComBoProts;              // The ComboBox for the network protocols
	CComboBox	m_ComBoTalker;             // The ComboBox for the users name list 
	CProgressCtrl	m_progctrlSend;        // Indicator of incoming voice message
	CProgressCtrl	m_progctrlRecv;        // Indicator of outgoing voice message
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTalkclientDlg)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CTalkclientDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
 	afx_msg LONG OnVTDataReady(WPARAM wparam, LPARAM lparam);
	afx_msg LONG OnVTReadyForWrite(WPARAM wparam, LPARAM lparam);
    afx_msg LONG OnRecordEvent(WPARAM wparam, LPARAM lparam);
    afx_msg LONG OnPlayEvent(WPARAM wparam, LPARAM lparam);
	afx_msg void OnChangeEditname();
	afx_msg void OnChangeEditserver();
	afx_msg void OnSelchangeCombprot();
	afx_msg void OnSelchangeCombchatter();
	afx_msg void OnBtnconnect();
	afx_msg void OnBtndisconnect();
	afx_msg void OnBtnsend();
	afx_msg void OnChkvoice();
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

protected:
	BOOL InitProtocols(void);
	BOOL InitSockets(int iProtIndex);
    void DoConnection(BOOL bTrue);
	void EnableTalking(BOOL bTrue);
	void ParseMsgData(void);
private:
	
	VTSOCKET            m_MySock;                // The socket in client side
    SOCKADDR_IPX        m_IPXAddr;               // The socket address for IPX
	SOCKADDR_NB         m_NBAddr;                // The socket address for NetBios
	char                m_szSendBuf[VT_MAX];     // The buffer for sending message
	char                m_szRecvBuf[VT_MAX];     // The buffer for receiving message
    char                m_lpPeerName[16];        // The peer taker name
    CSADDR_INFO         m_CSABuf[20];            // Socket address information
    DWORD               m_dwCSABufsize;          // Size of Socket address buffer structure
    int                 m_iWorkProts[30];        // Information of workable network protocol  
	int                 m_iNumWorkProts;         // Number of workable network protocol
    LPPROTOCOL_INFO     m_lpProtBuf;             // Buffer for protocol information
    VTMSG               m_vtRecvMsgBuf;          // Message structure for sending out  
    VTMSG               m_vtSendMsgBuf;          // Message structure for receiving

	BOOL                m_bConnect;              // Flag to check connection 
	BOOL                m_bTalking;              // Flag to check communcation
	BOOL	            m_bVoiceMsg;             // Flag to check message type, text or voice
    
	VTPlayWave          m_vtPlay;                // Device to play receiving voice message
    VTRecordWave        m_vtRecord;              // Device to record voice message to send out
	char                m_pWaveData[VT_MAX];     // Buffer to store receiving voice message
	unsigned int        m_uiBufLen;              // Buffer length of voice message
	int                 m_iWaveFormat;           // Wave I/O device type, see definition in vtDef.h

	CString	            m_strUserName;           // The user name
	CString     	    m_strServer;             // The server name
	BOOL                m_bVoiceTalk;            // Flag to check in voice tlaking or not

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TALKCLIENTDLG_H__8068D458_3CAB_11D4_8ECB_00805FBDCBE4__INCLUDED_)
